//
// UMAX scanner command implementation.
//   note that we implement the "Scanner" protocol, which consists of
//   two methods:
//      - performScan:(int)xstart :(int)ystart :(int)width :(int)length;
//      - performPreview;

#import <appkit/appkit.h>
#import <bsd/dev/scsireg.h>
#import "../scannerProtocol.h"

@interface UMAX:Object <Scanner>
{
    id	brightness;
    id	halfTonePattern;
    id	threshold;
	int scannerID;
	int LengthOfDescriptorBlock;
	int colorMode;
	int xresolution;
	int yresolution;
	int max_xresolution;
	int max_yresolution;
	int gammaFunction;
	int colorWindow;
	id colorWindowMatrix;
    NXBitmapImageRep *theScannedImage;
}

- init;
- loadnib;
- free;
- setScannerID:(int)scanner;
- setScannerUnit;
- findScanner;
- changeColorMode:sender;
- setResolution:sender;
- setGammaFunction:sender;
- setColorWindow:sender;
// scanner commands implemented
- getDataBufferStatus;
- inquiry;
- objectPosition;
- read:(int)xstart :(int)ystart :(int)width :(int)length;
- releaseUnit;
- requestSense;
- reserveUnit;
- scan:(BOOL)preview;
- send;
- setWindow:(int)xstart :(int)ystart :(int)width :(int)length;
- (int)testUnitReady;
- writeBuffer;
// end implemented scanner commands


- (int)readFromScanner:(u_char)opcode        // returns # bytes read
				 :(u_char *)returnDataPtr
				 :(int)Length
				 :(u_char)ctrl;

- (int)DoIoctl:(struct scsi_req *)Request;
- setWinDescriptorBlock:(int)window
	  :(int)xupperleft :(int)yupperleft
      :(int)width      :(int)length
	  :(u_char *)w_ptr;
- DumpScsi_Req:(struct scsi_req *)Request;
- (char *)Hex :(char *)String :(int) Length;
- (int)calcPixelWidth:(int)xstart :(int)width;
- (int)calcPixelHeight:(int)ystart :(int)length;

@end
